# module ActiveModel::AttributeAssignment

### Public Instance Methods

assign_attributes(new_attributes) click to toggle source

Allows you to set all the attributes by passing in a hash of attributes with keys matching the attribute names.

If the passed hash responds to `permitted?` method and the return value of this method is `false` an `ActiveModel::ForbiddenAttributesError` exception is raised.

    class Cat
      include ActiveModel::AttributeAssignment
      attr_accessor :name, :status
    end

    cat = Cat.new
    cat.assign_attributes(name: "Gorby", status: "yawning")
    cat.name # => 'Gorby'
    cat.status => 'yawning'
    cat.assign_attributes(status: "sleeping")
    cat.name # => 'Gorby'
    cat.status => 'sleeping'

    # File lib/active_model/attribute_assignment.rb, line 26
    def assign_attributes(new_attributes)
      if !new_attributes.respond_to?(:stringify_keys)
        raise ArgumentError, "When assigning attributes, you must pass a hash as an argument."
      end
      return if new_attributes.nil? || new_attributes.empty?

      attributes = new_attributes.stringify_keys
      _assign_attributes(sanitize_for_mass_assignment(attributes))
    end

### Private Instance Methods

_assign_attribute(k, v) click to toggle source

    # File lib/active_model/attribute_assignment.rb, line 44
    def _assign_attribute(k, v)
      if respond_to?("#{k}=")
        public_send("#{k}=", v)
      else
        raise UnknownAttributeError.new(self, k)
      end
    end

_assign_attributes(attributes) click to toggle source

    # File lib/active_model/attribute_assignment.rb, line 38
    def _assign_attributes(attributes)
      attributes.each do |k, v|
        _assign_attribute(k, v)
      end
    end